
application:setBackgroundColor(0x0f1f2f)

local function drawPath(path) -- draw a path to the display
  local shape = Shape.new()
  shape:clear()
  shape:setLineStyle(3, 0x44cc88, 0.25)
  shape:beginPath()
  local wp = path[#path] -- move cursor to first waypoint
  shape:moveTo(wp.x + 8, wp.y + 8)
  for i = 1, #path do -- draw lines between the points
    wp = path[i]
    shape:lineTo(wp.x + 8, wp.y + 8)
  end
  shape:endPath()
  stage:addChild(shape)
end

local path = { -- the path our agent will follow
  {x = 32 * 3, y = 32 * 0},
  {x = 32 * 3, y = 32 * 3},
  {x = 32 * 1, y = 32 * 3},
  {x = 32 * 1, y = 32 * 1},
  {x = 32 * 4, y = 32 * 1},
  {x = 32 * 4, y = 32 * 4},
  {x = 32 * 0, y = 32 * 4},
  {x = 32 * 0, y = 32 * 0},
}

drawPath(path) -- draw it so we can see where the agent will be moving

local agent = Agent.new(Texture.new("dragon.png")) -- our agent!
stage:addChild(agent)

agent:setPath(path)
agent:setState("patrol")

local function onEnterFrame(e) -- update every frame
  local dt = e.deltaTime
  agent:update(dt)
end

stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
